from Plugins.Plugin import PluginDescriptor
from Tools.Directories import pathExists
from enigma import getDesktop
from Screens.Screen import Screen
from Components.ActionMap import ActionMap
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.FileList import FileList
from os import system

def applySkinVars(skin,dict):
		for key in dict.keys():
				try:
						skin = skin.replace('{'+key+'}',dict[key])
				except Exception,e:
						print e,"@key=",key
		return skin

class STB_Startup(Screen):
	skin = """
		<screen position="center,center" size="{screen.size}" title="STB-Startup v1.00" >
			<widget name="filelist" position="{list.pos}" size="{list.size}" scrollbarMode="showOnDemand" />
			<widget name="textpage" position="{list.pos}" size="{list.size}" />
		</screen>"""

	def __init__(self, session):
		current_w = getDesktop(0).size().width()
		current_h = getDesktop(0).size().height()

		if current_w == 1280:
				size_w = 720
				size_h = 376
		else:
				size_w = 520
				size_h = 376

		font = "Regular;18"
		pos_w = (current_w - size_w)/2
		pos_h = (current_h - size_h)/2
		list_w = size_w - 20
		list_pos = (size_w - list_w)/2

		self.dict = {
				'font': font,
				'list.size': "%i,306"%(list_w),
				'list.pos': "%i,50"%(list_pos),
				'screen.size': "%i,%i"%(size_w,size_h)
				}
		self.skin = applySkinVars(STB_Startup.skin,self.dict)

		Screen.__init__(self, session)

		self["currentfolder"] = Label("")
		self["textpage"] =  ScrollLabel()
		self["textpage"].hide()

		self.LIST_TEXT = 1
		self.LIST_FILE = 2

		self.focus = self.LIST_FILE

		self["actions"] = ActionMap(["OkCancelActions", "DirectionActions"],
		{
			"ok": self.KeyOk,
			"cancel": self.Exit,
			"right": self.rightDown,
			"left": self.leftUp,
			"up": self.up,
			"down": self.down
		}, -1)

		self.SearchPattern = "^.*"

		self.filelist = []
		
		self.currDir = "/boot"
		if not pathExists(self.currDir):
			self.currDir = "/"

		self["currentfolder"].setText(self.currDir)

		self.filelist = FileList(self.currDir, showDirectories = False, showFiles = True, showMountpoints = False, isTop = True, matchingPattern = self.SearchPattern)

		self["filelist"] = self.filelist
		self["filelist"].show()

	def KeyOk(self):
		self.filename = self.filelist.getCurrentDirectory() + "/" + self.filelist.getFilename()
		self.filename_dest = self.filelist.getCurrentDirectory() + "/STARTUP"
		if self.filename is not None:
			cmdline = 'cp -f "%s" "%s"' % (self.filename, self.filename_dest)
			system(cmdline)

		self.text="Umgeschaltet auf <" + self.filelist.getFilename() + ">"
		self["filelist"].hide()
		self["textpage"].setText(str(self.text))
		self["textpage"].show()
		self.focus = self.LIST_TEXT

	def up(self):
		if self.focus is self.LIST_TEXT:
			self["textpage"].pageUp()
		else:
			self["filelist"].up()

	def down(self):
		if self.focus is self.LIST_TEXT:
			self["textpage"].pageDown()
		else:
			self["filelist"].down()

	def leftUp(self):
		self["filelist"].pageUp()

	def rightDown(self):
		self["filelist"].pageDown()

	def Exit(self):
		if self.focus is self.LIST_TEXT:
			self.focus = self.LIST_FILE
			self["filelist"].show()
			self["textpage"].hide()
		else:
			self.close()

def main(session, **kwargs):
	session.open(STB_Startup)

def Plugins(**kwargs):
	return [
		PluginDescriptor(name = "STB-Startup", description = "STB-Startup", where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main, icon = "stb-startup.png"),
		PluginDescriptor(name = "STB-Startup", description = "STB-Startup", where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main, icon = "stb-startup.png")]
